// +-------------------------------------------+
// |  ___   _     _____   __  __  ____   ____  |
// | | __| | |   | /_\ |  \ \/ / | ___| | /\ | |
// | |__ | | |_  |  _  |   \  /  | __|  | \/ / |
// | |___| |___| |_| |_|   |__|  |____| |_| \\ |
// |  Greek2me              Blockland ID 11902 |
// +-----------------------------+-------------+
// | DO NOT EDIT BELOW THIS LINE |
// +-----------------------------+

$Slayer::Client::Dependencies::Options = 1;

// +---------+
// | Options |
// +---------+
function SlayerClient_OptionsHandlerSO::onAdd(%this)
{
	%this.addOption("Auto Update","Enable","$Slayer::Client::AU::Enable","bool",1,"Options");
	%this.addOption("Welcome Screen","Display on Start","$Slayer::Client::Options::showStartScreen","bool",0,"Options");
	%this.addOption("Minigames","Notify Players on Update","$Slayer::Client::NotifyPlayersOnUpdate","bool",1,"Options");

	//little hack
	SlayerClient.Options = %this;

	if(isFile($Slayer::Client::ConfigDir @ "/config_last.cs"))
		exec($Slayer::Client::ConfigDir @ "/config_last.cs");
}

function SlayerClient_OptionsHandlerSO::addOption(%this,%category,%title,%variable,%type,%defaultValue,%list)
{
	%option = new scriptObject()
	{
		title = %title;
		category = %category;
		type = %type;
		variable = %variable;
		defaultValue = %defaultValue;
		list = %list;
	};
	%this.add(%option);
	if(isObject(missionCleanup) && missionCleanup.isMember(%option))
		missionCleanup.remove(%option);

	%value = eval(%variable SPC "= \"" @ %defaultValue @ "\";");
}

function SlayerClient_OptionsHandlerSO::setOption(%this,%category,%title,%value)
{
	%option = %this.getOptionSO(%category,%title);
	if(!isObject(%option))
		return;

	//idiot proofing
	switch$(%option.type)
	{
		case bool:
			if(%value !$= 0 && %value !$= 1)
				return;

		case string:
			%value = getSubStr(%value,0,getWord(%type,1));

		case int:
			if(!SlayerClient_Support::isNumber(%value))
				return;
			%value = SlayerClient_Support::StripTrailingZeros(%value);
			%value = SlayerClient_Support::mRestrict(%value,getWord(%type,1),getWord(%type,2));

		case slide:
			if(!SlayerClient_Support::isNumber(%value))
				return;
			%value = SlayerClient_Support::StripTrailingZeros(%value);
			%value = SlayerClient_Support::mRestrict(%value,getWord(%type,1),getWord(%type,2));
	}

	eval(%option.variable SPC "= \"" @ %value @ "\";");

	SlayerClient_Support::Debug(2,"Option Set",%category TAB %title TAB %value);

	%ctrl = Slayer_Options_Selector;
	if(isObject(%ctrl))
	{
		for(%i=0; %i < %ctrl.rowCount(); %i++)
		{
			%text = %ctrl.getRowText(%i);
			if(getField(%text,0) $= %category && getField(%text,1) $= %title)
			{
				switch$(getWord(%p.type,0))
				{
					case bool:
						if(%value)
							%val = "True";
						else
							%val = "False";
	
					case list:
						for(%i=0; %i < getFieldCount(%type); %i++)
						{
							%f = getField(%type,%i);
							if(firstWord(%f) $= %value)
							{
								%val = restWords(%f);
								break;
							}
						}
	
					default:
						%val = %value;
				}

				%id = %ctrl.getRowID(%i);
				%ctrl.setRowByID(%id,%category TAB %title TAB %val TAB %value TAB %p.defaultValue);

				break;
			}
		}
	}
}

function SlayerClient_OptionsHandlerSO::getOption(%this,%category,%title)
{
	%option = %this.getOptionSO(%category,%title);
	if(!isObject(%option))
		return;

	return eval("return" SPC %option.variable @ ";");
}

function SlayerClient_OptionsHandlerSO::getOptionSO(%this,%category,%title)
{
	for(%i=0; %i < %this.getCount(); %i++)
	{
		%p = %this.getObject(%i);
		if(%p.category $= %category && %p.title $= %title)
		{
			return %p;
		}
	}

	return 0;
}

function SlayerClient_OptionsHandlerSO::clearOptions(%this)
{
	for(%i=0; %i < %this.getCount(); %i++)
	{
		%p = %this.getObject(%i);
		%this.setOption(%p.category,%p.name,"");
	}
	%this.deleteAll();

	Slayer_Options_Selector.clear();
}

function SlayerClient_OptionsHandlerSO::exportOptions(%this,%path)
{
	%file = new fileObject() {};
	%file.openForWrite(%path);

	%file.writeLine("//Slayer -----" SPC getDateTime());
	%file.writeLine("//By Greek2me, Blockland ID 11902");
	%file.writeLine("");
	%file.writeLine("//Version:" SPC $Slayer::Client::Version);
	%file.writeLine("//Debug Mode:" SPC $Slayer::Client::Debug);
	%file.writeLine("//Core Directory:" SPC $Slayer::Client::Directory);
	%file.writeLine("//Config Directory:" SPC $Slayer::Client::ConfigDir);
	%file.writeLine("");
	%file.writeLine("$Slayer::Client::Debug =" SPC $Slayer::Client::Debug @ "; //For advanced users only. int 0-3");
	%file.writeLine("$Slayer::Client::LastVersion = \"" @ $Slayer::Client::Version @ "\"; //DO NOT EDIT!");
	%file.writeLine("");

	%file.writeLine("//OPTIONS //USAGE: (category,title,value)");
	for(%i=0; %i < %this.getCount(); %i++)
	{
		%p = %this.getObject(%i);
		%v = %this.getOption(%p.category,%p.title);

		%file.writeLine("SlayerClient.Options.setOption(\"" @ %p.category @ "\",\"" @ %p.title @ "\",\"" @ %v @ "\");");
	}

	%file.writeLine("");
	%file.writeLine("SlayerClient_Support::Debug(2,\"Options Loaded\",\"" @ %path @ "\");");

	%file.close();
	%file.delete();

	SlayerClient_Support::Debug(1,"Exporting Options",%path);
}

// +----------------------+
// | Initialize Component |
// +----------------------+
if(!isObject(SlayerClient.Options))
{
	if(!isObject(SlayerClient))
		exec("Add-ons/Gamemode_Slayer/Client/Main.cs");

	SlayerClient.Options = new scriptGroup(SlayerClient_OptionsHandlerSO);
	SlayerClient.add(SlayerClient.Options);
}

SlayerClient_Support::Debug(2,"Dependency Loaded","Options");