// +-------------------------------------------+
// |  ___   _     _____   __  __  ____   ____  |
// | | __| | |   | /_\ |  \ \/ / | ___| | /\ | |
// | |__ | | |_  |  _  |   \  /  | __|  | \/ / |
// | |___| |___| |_| |_|   |__|  |____| |_| \\ |
// |  Greek2me              Blockland ID 11902 |
// +-----------------------------+-------------+
// | DO NOT EDIT BELOW THIS LINE |
// +-----------------------------+

// +--------------+
// | SlayerClient |
// +--------------+
function SlayerClient::onAdd(%this)
{
	//DISPLAY INFO
	warn("Slayer Version" SPC $Slayer::Client::Version);
	warn(" + Compatible Versions:" SPC $Slayer::Client::CompatibleVersions);
	warn(" + Core Directory:" SPC $Slayer::Client::Directory);
	warn(" + Config Directory:" SPC $Slayer::Client::ConfigDir);
	warn(" + Debug Mode:" SPC $Slayer::Client::Debug);

	//DELETE PRE-V3 CONFIG FILES
	%this.DeleteOldConfigFiles();

	//INITIALIZE MAIN COMPONENTS
	SlayerClient_Support::LoadFiles($Slayer::Client::Directory @ "/Dependencies/*.cs"); //load dependencies

	if(!isObject(Slayer_WindowProfile))
		%this.createGUIProfiles();
	SlayerClient_Support::LoadFiles($Slayer::Client::Directory @ "/GUI/*init.cs"); //load GUI files

	SlayerClient_Support::LoadFiles($Slayer::Client::Directory @ "/Modules/*.cs"); //load modules

	//MINIGAME STATE
	%this.miniState = "NONE";
}

function SlayerClient::onRemove(%this)
{
	//export options config
	%this.Options.exportOptions($Slayer::Client::ConfigDir @ "/config_last.cs");

	//clear data
	%this.clearAllData();

	SlayerClient_Support::Debug(0,"Deactivating Slayer");

	//close the debug logger
	if(isObject(%this.debugFO))
		%this.debugFO.close();
}

function SlayerClient::sendData(%this,%reset)
{
	//GET NUMBER OF CHANGED PREFS
	%count = 0;
	for(%i=0; %i < %this.serverPrefs.getCount(); %i++) 
	{
		%p = %this.serverPrefs.getObject(%i);
		if(eval("return" SPC %p.variable @ ";") !$= %p.origValue)
			%count ++;
	}
	for(%i=0; %i < %this.Teams.getCount(); %i++)
	{
		%team = %this.Teams.getObject(%i);

		if(%team.ID < 0)
		{
			%count ++;
			break;
		}

		//get the number of changed prefs
		for(%e=0; %e < %this.TeamPrefs.getCount(); %e++)
		{
			%p = %this.TeamPrefs.getObject(%e);
			%orig = eval("return" SPC %team @ "." @ %p.variable @ "_ORIG;");
			%value = eval("return" SPC %team @ "." @ %p.variable @ ";");

			if(%orig !$= %value)
			{
				%changed = 1;
				break;
			}
		}

		if(%changed)
		{
			%count ++;
			break;
		}
	}
	%count += getFieldCount(%this.Teams.removeTeamList);

	SlayerClient_Support::Debug(1,"Sending Preferences",%count);

	//BEGIN PREF TRANSFER
	commandToServer('Slayer_getPrefs_Start',%reset,%count,$Slayer::Client::NotifyPlayersOnUpdate);

	//PREF TRANSFER TICK
	for(%i=0; %i < %this.serverPrefs.getCount(); %i++)
	{
		%p = %this.serverPrefs.getObject(%i);
		%val = eval("return" SPC %p.variable @ ";");
		if(%val !$= %p.origValue)
		{
			SlayerClient_Support::Debug(2,"Sending pref",%p.category TAB %p.title TAB %val);
			commandToServer('Slayer_getPrefs_Tick',%p.category,%p.title,%val);
		}
	}

	//SEND TEAMS
	%this.Teams.SendTeams();

	//END PREF TRANSFER
	commandToServer('Slayer_getPrefs_End');
}

function SlayerClient::clearAllData(%this)
{
	SlayerClient_Support::Debug(1,"Clearing data");

	%this.serverPrefs.clearPrefs();
	%this.serverPrefs.clearRules("ALL");
	%this.Teams.clearTeams();
	%this.Gamemodes.deleteAll();

	Slayer_Main_Announcements_Text.clearMessages("SERVER");

	for(%i=0; %i < 5; %i++)
	{
		%ctrl = Slayer_General_Player_StartEquip @ %i;
		%ctrl.clear();

		%ctrl = Slayer_Teams_Edit_StartEquip @ %i;
		%ctrl.clear();
	}
	Slayer_General_Player_datablock.clear();
	Slayer_Teams_Edit_Datablock.clear();
	Slayer_General_Mode_Selector.clear();

	//JOIN MINIGAME GUI
	JMG_Slayer.setVisible(0);
	JMG_Slayer_Default.setVisible(0);
	JMG_List.columns = "0 102 165 493";

	SlayerClient.serverHasSlayer = 0;
}

function SlayerClient::DeleteOldConfigFiles(%this)
{
	%path = $Slayer::Client::ConfigDir;

	if(isFile(%path @ "/Config.cs"))
	{
		fileDelete(%path @ "/Config.cs");
		%warn = 1;
	}

	if(isFile(%path @ "/client.log"))
	{
		fileDelete(%path @ "/client.log");
		%warn = 1;
	}

	%favs = %path @ "/Favorites";
	for(%i=0; %i < 10; %i++)
	{
		%file = %favs @ "/Fav" @ %i @ ".cs";

		if(isFile(%file))
		{
			fileDelete(%file);
			%warn = 1;
		}
	}

	if(%warn)
		SlayerClient_Support::Error("Deleting old config files");
}

function SlayerClient::createGUIProfiles(%this)
{
	%fontColor = "30 30 30 255";

	new GuiControlProfile(Slayer_ButtonProfile : blockButtonProfile)
	{
		fontColor = %fontColor;
		fontType = "Arial Bold";
		fontSize = "16";
		justify = "Center";
		fontColors[1] = "100 100 100";
		fontColors[2] = "30 30 30 150";  
		fontColors[3] = "0 0 255"; 
		fontColors[4] = "255 255 0"; 
		fontColorLink = "60 60 60 255";
		fontColorLinkHL = "0 0 0 255";
	};

	new GuiControlProfile(Slayer_TabTextProfile)
	{
		fontColor = %fontColor;
		fontType = "Arial";
		fontSize = "17";
		justify = "Left";
		fontColors[1] = "100 100 100";
		fontColors[2] = "0 255 0";  
		fontColors[3] = "0 0 255"; 
		fontColors[4] = "255 255 0"; 
		fontColorLink = "60 60 60 255";
		fontColorLinkHL = "0 0 0 255";
	};

	new GuiControlProfile(Slayer_TabBlueTextProfile)
	{
		fontColor = "0 0 255 255";
		fontType = "Arial";
		fontSize = "17";
		justify = "Left";
		fontColors[1] = "100 100 100";
		fontColors[2] = "0 255 0";  
		fontColors[3] = "0 0 255"; 
		fontColors[4] = "255 255 0"; 
		fontColorLink = "60 60 60 255";
		fontColorLinkHL = "0 0 0 255";
	};

	new GuiControlProfile(Slayer_TextProfile)
	{
		fontColor = %fontColor;
		fontType = "Arial";
		fontSize = "15";
		justify = "Left";
		fontColors[1] = "100 100 100";
		fontColors[2] = "0 255 0";  
		fontColors[3] = "0 0 255"; 
		fontColors[4] = "255 255 0"; 
		fontColorLink = "60 60 60 255";
		fontColorLinkHL = "0 0 0 255";
	};

	new GuiControlProfile(Slayer_CheckBoxProfile : GuiCheckBoxProfile)
	{
		fontColor = %fontColor;
		fontType = "Arial";
		fontSize = "15";
	};

	new GuiControlProfile(Slayer_PopUpMenuProfile : GuiPopupMenuProfile)
	{
		fontSize = "15";
	};

	new GuiControlProfile(Slayer_WindowProfile : GuiWindowProfile)
	{
		fontType = "Arial Bold";
		fontSize = "18";
		textOffset = "5 3";
	};
}

function SlayerClient::editMinigame(%this,%mini)
{
	if(!%this.DataRecieved)
		commandToServer('Slayer',Edit,%mini);

	canvas.pushDialog(Slayer_Main);
}

// +------------+
// | clientCmds |
// +------------+
function clientCmdSlayer_Handshake(%version,%modVersions)
{
	SlayerClient_Support::Debug(0,"Handshake Recieved","Server has Version" SPC %version);

	if(%version !$= $Slayer::Client::Version)
	{
		for(%i=0; %i < getFieldCount($Slayer::Client::CompatibleVersions); %i++)
		{
			%f = getField($Slayer::Client::CompatibleVersions,%i);
			if(%f $= %version)
			{
				%clVersion = %f;
				break;
			}
		}
	}

	if(%clVersion $= "")
		%clVersion = $Slayer::Client::Version;

	commandToServer('Slayer_Handshake',%clVersion,$Slayer::Client::modVersions);
}

function clientCmdSlayer_getInitialData_Start()
{
	SlayerClient_Support::Debug(0,"Handshake Accepted","Recieving initial data...");

	//make sure that everything is cleared before we recieve new data
	SlayerClient.clearAllData();

	SlayerClient.serverHasSlayer = 1;

	JMG_Slayer.setVisible(1);
	JMG_Slayer_Default.setVisible(1);
	JMG_List.columns = "0 102 165 490 450";
}

function clientCmdSlayer_getInitialData_End()
{
	SlayerClient_Support::Debug(1,"Initial Data Recieved");

	//create item and player lists
	if(serverConnection.isLocal())
		%group = datablockGroup;
	else
		%group = serverConnection;
	if(isObject(%group))
	{
		%count = %group.getCount();
		for(%i=0; %i < %count; %i++)
		{
			%obj = %group.getObject(%i);
			%cn = %obj.getClassName();
			if(%cn $= "MissionArea")
				break;
			if(%obj.uiName $= "")
				continue;
			if(%cn $= "ItemData")
			{
				for(%e=0; %e < 5; %e++)
				{
					%ctrl = Slayer_General_Player_StartEquip @ %e;
					%ctrl.add(%obj.uiName,%obj);

					%ctrl = Slayer_Teams_Edit_StartEquip @ %e;
					%ctrl.add(%obj.uiName,%obj);
				}
				SlayerClient_Support::Debug(2,"ItemData Added",%obj TAB %obj.uiName);
			}
			else if(%cn $= "PlayerData")
			{
				Slayer_General_Player_Datablock.add(%obj.uiName,%obj);
				Slayer_Teams_Edit_Datablock.add(%obj.uiName,%obj);
				SlayerClient_Support::Debug(2,"PlayerData Added",%obj TAB %obj.uiName);
			}
		}
	}
	else
	{
		SlayerClient_Support::Error("Unable to generate datablock lists","Group not found!");
	}

	//add the NONE values and sort lists
	for(%i=0; %i < 5; %i++)
	{
		%ctrl = Slayer_General_Player_StartEquip @ %i;
		if(isObject(%ctrl))
		{
			%ctrl.sort();
			%ctrl.addFront("NONE",0);
		}

		%ctrl = Slayer_Teams_Edit_StartEquip @ %i;
		if(isObject(%ctrl))
		{
			%ctrl.sort();
			%ctrl.addFront("NONE",0);
		}
	}
	Slayer_General_Player_datablock.sort();
	Slayer_Teams_Edit_datablock.sort();
}

function clientCmdSlayer_getData_Start(%mini,%adminLevel,%miniState)
{
	Slayer_Main_Content_Loading_Status.setText("Recieving Data");

	SlayerClient.editingMinigame = %mini;

	SlayerClient.adminLevel = %adminLevel;

	SlayerClient.miniState = %miniState;
	if(%miniState $= "NONE")
	{
		Slayer_Main_Buttons_Update.setActive(0);
		Slayer_Main_Buttons_Reset.setActive(0);
		Slayer_Main_Buttons_End.setActive(0);
	}
	else
	{
		if(%miniState $= "EDIT")
		{
			Slayer_Main_Buttons_Update.setText("Update");
			Slayer_Main_Buttons_Reset.setActive(1);
			Slayer_Main_Buttons_End.setActive(1);
		}
		else if(%miniState $= "CREATE")
		{
			Slayer_Main_Buttons_Update.setText("Create");
			Slayer_Main_Buttons_Reset.setActive(0);
			Slayer_Main_Buttons_End.setActive(0);
		}
		Slayer_Main_Buttons_Update.setActive(1);
	}
}

function clientCmdSlayer_getData_End(%gui)
{
	SlayerClient.DataRecieved = 1;

	Slayer_Main_Content_Loading_Status.setText("");

	if(%gui $= "Slayer_Main" && Slayer_Main.isAwake())
	{
		if(Slayer_Main_Content_Loading.isVisible())
			Slayer_Main_TabList.setSelectedById(0);	
		Slayer_Main.refreshAllValues(); //refresh GUI values
	}
	else if(isObject(%gui))
		canvas.pushDialog(%gui);
}

function clientCmdSlayer_getMiniState(%miniState,%canEditCurrent)
{
	SlayerClient.miniState = %miniState;
	SlayerClient.canEditCurrent = %canEditCurrent;

	if(JMG_Slayer.isVisible())
		JMG_Slayer.onWake();

	if(NewPlayerListGui.isAwake())
		NewPlayerListGui.clickList();
}

// +--------------------+
// | Packaged Functions |
// +--------------------+
package Slayer_Client_Main
{
	function disconnect(%a)
	{
		parent::disconnect(%a);

		if(isObject(SlayerClient))
		{
			SlayerClient.clearAllData();

			SlayerClient_Support::Debug(0,"Disconnecting from server");
		}
	}

	function onExit()
	{
		parent::onExit();

		if(isObject(SlayerClient))
			SlayerClient.delete();
	}
};
activatePackage(Slayer_Client_Main);

// +-------------------+
// | Initialize Slayer |
// +-------------------+
if(!isObject(SlayerClient))
{
	$Slayer::Client = new scriptGroup(SlayerClient);
}