// +-------------------------------------------+
// |  ___   _     _____   __  __  ____   ____  |
// | | __| | |   | /_\ |  \ \/ / | ___| | /\ | |
// | |__ | | |_  |  _  |   \  /  | __|  | \/ / |
// | |___| |___| |_| |_|   |__|  |____| |_| \\ |
// |  Greek2me              Blockland ID 11902 |
// +-----------------------------+-------------+
// | DO NOT EDIT BELOW THIS LINE |
// +-----------------------------+

$Slayer::Client::Modules::AU = 1;

$Slayer::Client::AU::ServerURL = "greekmods.webs.com:80";
$Slayer::Client::AU::ServerDir = "/mods/Gamemode_Slayer/Updater/version_Release.txt";

if(!isObject(SlayerClient.AUHTTP))
{
	if(!isObject(SlayerClient))
		exec("Add-ons/Gamemode_Slayer/Client/Main.cs");

	SlayerClient.AUHTTP = new HTTPObject(SlayerClient_AutoUpdateHTTP);
	SlayerClient.add(SlayerClient.AUHTTP);
}

if(!isObject(SlayerClient.CLHTTP))
{
	if(!isObject(SlayerClient))
		exec("Add-ons/Gamemode_Slayer/Client/Main.cs");

	SlayerClient.CLHTTP = new HTTPObject(SlayerClient_ChangeLogHTTP);
	SlayerClient.add(SlayerClient.CLHTTP);
}

// +-------------------+
// | Check for updates |
// +-------------------+
function SlayerClient_AutoUpdateHTTP::CheckForUpdate(%this)
{
	deleteVariables("$Slayer::Client::AU::newVersion*");
	$Slayer::Client::AU::newVersion = "";

	//PREVIOUS UPDATE WAS SUCCESSFUL
	if($Slayer::Client::Update)
	{
		if(isObject(RTB_Overlay))
			canvas.popDialog(RTB_Overlay);

		if($Slayer::Client::Update::RequiresRestart)
		{
			setPopup(canvas,0,"YESNO","exclamation","Slayer | Update","<just:center>\nSlayer will not work until you restart Blockland.\n\nClose Blockland now?","quit();");
		}
		else
		{
			setPopup(canvas,0,"OK","information","Slayer | Update","<just:center>\nUpdate Complete!\n\nYou were successfully updated from Slayer v" @ $Slayer::Client::Update::OldVersion SPC "to Slayer v" @ $Slayer::Client::Version @ ".");
		}

		deleteVariables("$Slayer::Client::Update*");
		$Slayer::Client::Update = "";
	}
	else
	{
		%this.get($Slayer::Client::AU::ServerURL,$Slayer::Client::AU::ServerDir);
	}
}

function SlayerClient_AutoUpdateHTTP::onLine(%this,%line)
{
	SlayerClient_Support::Debug(2,"Auto Update Line Recieved",%line);

	%flag = firstWord(%line);
	%value = restWords(%line);

	switch$(%flag)
	{
		case "currentVersion:":
			if(%value !$= $Slayer::Client::Version)
			{
				SlayerClient_Support::Debug(0,"New version available",%value);
				$Slayer::Client::AU::newVersion = %value;
			}
			else
				%this.disconnect();

		case "downloadURL:":
			if($Slayer::Client::AU::newVersion $= "")
				return;

			SlayerClient_Support::Debug(0,"Download Version" SPC $Slayer::Client::AU::newVersion SPC "at",%value);

			%pos = strPos(%value,"/");
			$Slayer::Client::AU::newVersion::URL = getSubStr(%value,0,%pos);
			$Slayer::Client::AU::newVersion::Dir = getSubStr(%value,%pos,strLen(%value));

			Slayer_Options_Updates_Text.setText("<just:center>New version available:" SPC $Slayer::Client::AU::newVersion);
			Slayer_Options_Updates_Button.setText("Download");
			Slayer_Options_Updates_Button.command = "canvas.pushDialog(Slayer_Update); $Slayer::Client::AU::DisablePromptDisplayed = 1;";

			if($Slayer::Client::AU::Enable && !$Slayer::Client::AU::UpdateDisplayed)
				canvas.pushDialog(Slayer_Update);

		case "rtbFileID:":
			if($Slayer::Client::AU::newVersion $= "")
				return;

			$Slayer::Client::AU::newVersion::rtbFileID = %value;

		case "changeLogURL:":
			if($Slayer::Client::AU::newVersion $= "")
				return;

			%pos = strPos(%value,"/");
			$Slayer::Client::AU::ChangeLog::URL = getSubStr(%value,0,%pos);
			$Slayer::Client::AU::ChangeLog::Dir = getSubStr(%value,%pos,strLen(%value));

			SlayerClient.CLHTTP.DownloadChangeLog();

		case "clientRequiresRestart:":
			if($Slayer::Client::AU::newVersion $= "")
				return;

			$Slayer::Client::AU::newVersion::RequiresRestart = %value;

		case "announcement:":
			if(%value $= "")
				return;

			%val = "<bullet>" @ %value;
			%val = SlayerClient_Support::parseML(%val);
			%ctrl = Slayer_Main_Content_StartScreen_Announcements;
			%text = %ctrl.getText();
			if(%text $= "")
				%ctrl.setText(%val);
			else
				%ctrl.setText(%text @ "\n\n" @ %val);

			%val = stripMLControlChars(%value);
			Slayer_Main_Announcements_Text.addMessage(%val,"WEB");
	}
}

// +-------------------------+
// | Download the Change Log |
// +-------------------------+
function SlayerClient_ChangeLogHTTP::DownloadChangeLog(%this)
{
	%this.get($Slayer::Client::AU::ChangeLog::URL @ ":80",$Slayer::Client::AU::ChangeLog::Dir);
}

function SlayerClient_ChangeLogHTTP::onConnected(%this)
{
	$Slayer::Client::AU::ChangeLog = "";
}

//error handling
function SlayerClient_ChangeLogHTTP::onConnectFailed(%this)
{
	Slayer_Update_CL_Text.setText("<just:center>\n\nError Retrieving Change Log:\nUnspecified Error");
}

function SlayerClient_ChangeLogHTTP::onLine(%this,%line)
{
	SlayerClient_Support::Debug(2,"Change Log Line Recieved",%line);

	%value = trim(%line);

	if(striPos(%line,"<title>Not Found - Webs.com</title>") >= 0)
	{
		%this.disconnect();
		Slayer_Update_CL_Text.schedule(0,setText,"<just:center>\n\nError Retrieving Change Log:\n404 File Not Found");
		return;
	}

	%value = SlayerClient_Support::parseML(%value);

	%cl = $Slayer::Client::AU::ChangeLog;
	if(%cl $= "" || %cl $= Slayer_Update_CL_Text.text)
		$Slayer::Client::AU::ChangeLog = %value;
	else
		$Slayer::Client::AU::ChangeLog = %cl @ %value;

	Slayer_Update_CL_Text.setText($Slayer::Client::AU::ChangeLog);
}

// +-------------+
// | Auto Update |
// +-------------+
SlayerClient.AUHTTP.checkForUpdate();

SlayerClient_Support::Debug(2,"Module Loaded","AU");