// +-------------------------------------------+
// |  ___   _     _____   __  __  ____   ____  |
// | | __| | |   | /_\ |  \ \/ / | ___| | /\ | |
// | |__ | | |_  |  _  |   \  /  | __|  | \/ / |
// | |___| |___| |_| |_|   |__|  |____| |_| \\ |
// |  Greek2me              Blockland ID 11902 |
// +-----------------------------+-------------+
// | DO NOT EDIT BELOW THIS LINE |
// +-----------------------------+

$Slayer::Server::Dependencies::Preferences = 1;

// +----------------------+
// | Slayer_PrefHandlerSO |
// +----------------------+
function Slayer_PrefHandlerSO::onAdd(%this)
{
	Slayer.Prefs = %this;

	//CREATE PREFERENCES
	%this.schedule(0,loadPrefs);
}

function Slayer_PrefHandlerSO::addPref(%this,%category,%title,%variable,%type,%defaultValue,%requiresReset,%notify,%editRights,%list,%callback,%preload)
{
	%p = %this.getPrefSO(%category,%title);
	if(isObject(%p))
	{
		%p.delete();
		Slayer_Support::Debug(1,"Overwriting Preference",%category TAB %title);
	}

	%className = getField(%variable,1);

	%pref = new scriptObject()
	{
		class = Slayer_PrefSO;

		title = %title;
		category = %category;
		type = %type;
		variable = getField(%variable,0);
		defaultValue = %defaultValue;
		requiresReset = %requiresReset;
		notify = %notify;
		editRights = %editRights;
		isObject = (%className !$= "0" && %className !$= "");
		objectClassName = %className;
		objectCannotBeNull = getField(%variable,2);
		list = %list;
		callback = %callback;
		preload = %preload;
	};
	%this.add(%pref);
	if(isObject(missionCleanup) && missionCleanup.isMember(%pref))
		missionCleanup.remove(%pref);

	if(striPos(%variable,"%mini.") < 0)
	{
		%val = eval("return" SPC %variable @ ";");
		if(!%preload || %val $= "")
			eval(%variable SPC "= \"" @ %defaultValue @ "\";");
	}

	return %pref;
}

function Slayer_PrefHandlerSO::setPref(%this,%category,%title,%value,%mini) //set the value of a pref
{
	%pref = %this.getPrefSO(%category,%title);
	if(!isObject(%pref))
		return;

	if(isObject(%mini))
	{
		if(%pref.preload)
		{
			if(%mini != Slayer.Minigames.getHostMinigame())
				return;
		}
	}

	%isMinigameVar = (striPos(%pref.variable,"%mini.") >= 0);

	if(Slayer.isStarting || (isObject(%mini) && %mini.isStarting && %mini.isDedicatedStart))
	{
		if(%isMinigameVar)
		{
			if(Slayer.isStarting)
			{
				return;
			}
		}
		else
		{
			if(%this.setNonMinigamePrefs)
			{
				return;
			}
		}
	}

	if(%pref.isObject)
	{
		if(!isObject(%value))
		{
			if(%pref.objectCannotBeNull)
				return;
			%value = 0;
		}
		else
		{
			%className = %value.getClassName();
			if(%pref.objectClassName !$= %className && %pref.objectClassName !$= "ALL")
				return;
		}
	}

	if(%pref.callback !$= "")
	{
		%callback = strReplace(%pref.callback,"%1","\"" @ %value @ "\"");
		%callback = strReplace(%callback,"%2","\"" @ %this.getPref(%category,%title,%mini) @ "\"");

		if(strPos(%callback,"%mini") >= 0)
		{
			if(isSlayerMinigame(%mini))
				%callback = strReplace(%callback,"%mini",%mini);
			else
				return;
		}
	}

	%var = %pref.variable;
	if(%isMinigameVar)
	{
		if(isSlayerMinigame(%mini))
			%var = strReplace(%var,"%mini",%mini);
		else
			return;
	}

	eval(%var SPC "= \"" @ %value @ "\";");

	Slayer_Support::Debug(2,"Preference Set",%category TAB %title TAB %value);

	if(%callback !$= "")
		eval(%callback);
}

function Slayer_PrefHandlerSO::getPref(%this,%category,%title,%mini) //get the value of a pref
{
	%pref = %this.getPrefSO(%category,%title);
	if(!isObject(%pref))
		return;

	%var = %pref.variable;
	if(strPos(%var,"%mini") >= 0)
	{
		if(isSlayerMinigame(%mini))
			%var = strReplace(%var,"%mini",%mini);
		else
			return %pref.defaultValue;
	}

	return eval("return" SPC %var @ ";");
}

function Slayer_PrefHandlerSO::getPrefSO(%this,%category,%title) //get the SO of a pref
{
	for(%i=0; %i < %this.getCount(); %i++)
	{
		%pref = %this.getObject(%i);
		if(%pref.category $= %category && %pref.title $= %title)
		{
			return %pref;
		}
	}

	return 0;
}

function Slayer_PrefHandlerSO::resetPrefs(%this,%mini) //return all prefs to default values
{
	for(%i=0; %i < %this.getCount(); %i++)
	{
		%pref = %this.getObject(%i);

		if(isObject(%mini))
		{
			if(striPos(%pref.variable,"%mini.") < 0)
				continue;
		}

		%this.setPref(%pref.category,%pref.title,%pref.defaultValue,%mini);
	}
}

function Slayer_PrefHandlerSO::exportPrefs(%this,%path,%mini)
{
	%file = new fileObject();
	%file.openForWrite(%path);

	%file.writeLine("//Slayer -----" SPC getDateTime());
	%file.writeLine("//By Greek2me, Blockland ID 11902");
	%file.writeLine("");
	%file.writeLine("//Version:" SPC $Slayer::Server::Version);
	%file.writeLine("//Debug Mode:" SPC $Slayer::Server::Debug);
	%file.writeLine("//Core Directory:" SPC $Slayer::Server::Directory);
	%file.writeLine("//Config Directory:" SPC $Slayer::Server::ConfigDir);
	%file.writeLine("");
	%file.writeLine("if(isObject(%mini))");
	%file.writeLine("\t%mini.preConfigLoad();");
	%file.writeLine("");

	%file.writeLine("//PREFERENCES //USAGE: (category,title,value)");
	for(%i=0; %i < %this.getCount(); %i++)
	{
		%p = %this.getObject(%i);
		if(%p.preload)
			continue;
		%var = %p.variable;
		if(strPos(%var,"%mini") >= 0)
		{
			if(!isSlayerMinigame(%mini))
			{
				continue;
			}
		}

		%v = %this.getPref(%p.category,%p.title,%mini);			

		if(%p.isObject)
		{
			if(isObject(%v))
				%var = "nameToID(" @ %v.getName() @ ")";
			else
				%var = 0;
			%file.writeLine("Slayer.Prefs.setPref(\"" @ %p.category @ "\",\"" @ %p.title @ "\"," @ %var @ ",%mini);");
		}
		else
		{
			%file.writeLine("Slayer.Prefs.setPref(\"" @ %p.category @ "\",\"" @ %p.title @ "\",\"" @ %v @ "\",%mini);");
		}
	}

	%teams = %mini.Teams;
	if(isObject(%teams))
	{
		if(%teams.getCount() > 0)
		{
			%file.writeLine("");
			%file.writeLine("//TEAMS");
			%file.writeLine("if(isObject(%mini.Teams))");
			%file.writeLine("{");
			for(%i=0; %i < %teams.getCount(); %i++)
			{
				%t = %teams.getObject(%i);
	
				if(%t.isSpecialTeam)
					continue;
	
				%file.writeLine("\t%team = %mini.Teams.addTeam();");
				for(%e=0; %e < %teams.Prefs.getCount(); %e++)
				{
					%p = %teams.Prefs.getObject(%e);
					%v = %teams.Prefs.getPref(%t,%p.category,%p.title);
	
					if(%p.isObject)
					{
						if(isObject(%v))
							%var = "nameToID(" @ %v.getName() @ ")";
						else
							%var = 0;
						%file.writeLine("\t\t%mini.TeamPrefs.setPref(%team,\"" @ %p.category @ "\",\"" @ %p.title @ "\"," @ %var @ ");");
					}
					else
						%file.writeLine("\t\t%mini.TeamPrefs.setPref(%team,\"" @ %p.category @ "\",\"" @ %p.title @ "\",\"" @ %v @ "\");");
				}
			}
			%file.writeLine("}");
		}
	}

	%file.writeLine("");
	%file.writeLine("if(isObject(%mini))");
	%file.writeLine("\t%mini.postConfigLoad();");

	%file.close();
	%file.delete();

	for(%i=0; %i < Slayer.Gamemodes.getCount(); %i++)
	{
		%m = Slayer.Gamemodes.getObject(%i);
		if(isFunction("Slayer_" @ %m.fName @ "_onExportPrefs"))
			call("Slayer_" @ %m.fName @ "_onExportPrefs",%path);
	}

	Slayer_Support::Debug(1,"Exporting Preferences",%path);
}

function Slayer_PrefHandlerSO::exportPreload(%this,%path)
{
	%file = new fileObject() {};
	%file.openForWrite(%path);

	%file.writeLine("//Slayer -----" SPC getDateTime());
	%file.writeLine("//By Greek2me, Blockland ID 11902");
	%file.writeLine("");
	%file.writeLine("//Version:" SPC $Slayer::Server::Version);
	%file.writeLine("//Debug Mode:" SPC $Slayer::Server::Debug);
	%file.writeLine("//Core Directory:" SPC $Slayer::Server::Directory);
	%file.writeLine("//Config Directory:" SPC $Slayer::Server::ConfigDir);
	%file.writeLine("");
	%file.writeLine("$Slayer::Server::Debug =" SPC $Slayer::Server::Debug @ "; //For advanced users only. int 0-3");
	%file.writeLine("$Slayer::Server::LastVersion = \"" @ $Slayer::Server::Version @ "\"; //DO NOT EDIT!");
	%file.writeLine("");

	%file.writeLine("//PREFERENCES");
	%file.close();
	%file.delete();

	export("$Slayer::Server::Preload::*",%path,1);

	for(%i=0; %i < Slayer.Gamemodes.getCount(); %i++)
	{
		%m = Slayer.Gamemodes.getObject(%i);
		if(isFunction("Slayer_" @ %m.fName @ "_onExportPreload"))
			call("Slayer_" @ %m.fName @ "_onExportPreload",%path);
	}

	Slayer_Support::Debug(1,"Exporting Preload",%path);
}

function Slayer_PrefHandlerSO::loadPrefs(%this)
{
	//This is how you add preferences.
	//Slayer.Prefs.addPref(category,title,variable,control type,default,requires reset,notify,editRights,list,callback,preload);
	%this.addPref("Permissions","Create Minigame Rights","Slayer.Minigames.createRights","list" TAB "0 Host" TAB "1 Super Admin" TAB "2 Admin",1,0,1,0,"Advanced");
	%this.addPref("Permissions","Edit Rights","%mini.editRights","list" TAB "3 Creator" TAB "4 Full Trust" TAB "5 Build Trust" TAB "0 Host" TAB "1 Super Admin" TAB "2 Admin",3,0,1,3,"Advanced");
	%this.addPref("Permissions","Leave Rights","%mini.leaveRights","list" TAB "3 Creator" TAB "4 Full Trust" TAB "5 Build Trust" TAB "0 Host" TAB "1 Super Admin" TAB "2 Admin" TAB "6 Everyone",2,0,1,3,"Advanced");
	%this.addPref("Permissions","Reset Rights","%mini.resetRights","list" TAB "3 Creator" TAB "4 Full Trust" TAB "5 Build Trust" TAB "0 Host" TAB "1 Super Admin" TAB "2 Admin",3,0,1,3,"Advanced");

	%this.addPref("Minigame","Auto Start With Server","$Slayer::Server::Preload::Minigame::AutoStartMinigame","bool",0,0,0,0,"Advanced","",1);

	%this.addPref("Minigame","Custom Rule","%mini.customRule","string 150","",0,0,-1,"Advanced");
	%this.addPref("Minigame","Host Name","%mini.hostName","string 25","HOST",0,0,3,"Advanced");
	%this.addPref("Minigame","Enable Building","%mini.enableBuilding","bool",1,0,1,-1,"","%mini.updateEnableBuilding();");
	%this.addPref("Minigame","Enable Painting","%mini.enablePainting","bool",1,0,1,-1,"","%mini.updateEnablePainting();");
	%this.addPref("Minigame","Enable Wand","%mini.enableWand","bool",1,0,1,-1);
	%this.addPref("Minigame","Late Join Time","%mini.lateJoinTime","slide -1 5 5 1",-1,0,1,-1,"Advanced");
	%this.addPref("Minigame","Use All Players' Bricks","%mini.useAllPlayersBricks","bool",0,0,1,-1);
	%this.addPref("Minigame","Players Use Own Bricks","%mini.playersUseOwnBricks","bool",0,0,1,-1);
	%this.addPref("Minigame","Invite-Only","%mini.inviteOnly","bool",0,0,1,4);
	%this.addPref("Minigame","Title","%mini.Title","string 50","Slayer",0,1,-1);
	%this.addPref("Minigame","Use Spawn Bricks","%mini.useSpawnBricks","bool",1,0,1,-1);

	%this.addPref("Damage","Brick","%mini.brickDamage","bool",1,0,1,-1);
	%this.addPref("Damage","Falling","%mini.fallingDamage","bool",1,0,1,-1);
	%this.addPref("Damage","Self","%mini.selfDamage","bool",1,0,1,-1);
	%this.addPref("Damage","Vehicle","%mini.vehicleDamage","bool",1,0,1,-1);
	%this.addPref("Damage","Weapon","%mini.weaponDamage","bool",1,0,1,-1);

	%this.addPref("Respawn Time","Player","%mini.respawnTime_player","int 0 999",5,0,1,-1,"","%mini.updateRespawnTime(player,%1,%2);");
	%this.addPref("Respawn Time","Brick","%mini.respawnTime_brick","int -1 999",30,0,1,-1,"","%mini.updateRespawnTime(brick,%1,%2);");
	%this.addPref("Respawn Time","Vehicle","%mini.respawnTime_vehicle","int 0 999",10,0,1,-1,"","%mini.updateRespawnTime(vehicle,%1,%2);");
	%this.addPref("Respawn Time","Friendly Fire Penalty","%mini.respawnPenalty_FriendlyFire","int 0 999",5,0,1,-1,"Rules Teams Respawn","%mini.updateRespawnTime(penalty_FF,%1,%2);");

	%this.addPref("Player","Playertype","%mini.playerDatablock" TAB "PlayerData" TAB 1,"string 100",nameToID(playerStandardArmor),0,0,-1,"","%mini.updatePlayerDatablock();");
	%this.addPref("Player","Starting Equipment 0","%mini.startEquip0" TAB "ItemData","string 100",nameToID(hammerItem),0,0,-1,"","%mini.updateEquip(0,%1,%2);");
	%this.addPref("Player","Starting Equipment 1","%mini.startEquip1" TAB "ItemData","string 100",nameToID(wrenchItem),0,0,-1,"","%mini.updateEquip(1,%1,%2);");
	%this.addPref("Player","Starting Equipment 2","%mini.startEquip2" TAB "ItemData","string 100",nameToID(printGun),0,0,-1,"","%mini.updateEquip(2,%1,%2);");
	%this.addPref("Player","Starting Equipment 3","%mini.startEquip3" TAB "ItemData","string 100",0,0,0,-1,"","%mini.updateEquip(3,%1,%2);");
	%this.addPref("Player","Starting Equipment 4","%mini.startEquip4" TAB "ItemData","string 100",0,0,0,-1,"","%mini.updateEquip(4,%1,%2);");
	%this.addPref("Player","Name Distance","%mini.nameDistance","slide 0 600 11 1",150,0,1,-1,"","%mini.updateNameDistance(%1);");

	%this.addPref("Points","Break Brick","%mini.points_breakBrick","int -999 999",0,0,1,-1);
	%this.addPref("Points","Die","%mini.points_die","int -999 999",0,0,1,-1);
	%this.addPref("Points","Kill","%mini.points_killPlayer","int -999 999",1,0,1,-1);
	%this.addPref("Points","Plant Brick","%mini.points_plantBrick","int -999 999",0,0,1,-1);
	%this.addPref("Points","Suicide","%mini.points_killSelf","int -999 999",-1,0,1,-1);
	%this.addPref("Points","Friendly Fire","%mini.points_friendlyFire","int -999 999",-5,0,1,-1,"Rules Teams Points");
	%this.addPref("Points","CP Capture","%mini.points_CP","int -999 999",10,0,1,-1,"Rules Teams Points");

	%this.addPref("Minigame","Clear Scores on Reset","%mini.clearScores","bool",1,0,1,-1,"Advanced");
	%this.addPref("Minigame","Clear Stats on Reset","%mini.clearStats","bool",1,0,1,-1,"Advanced");
	%this.addPref("Minigame","Time Between Rounds","%mini.timeBetweenRounds","int 5 300",10,0,1,4,"Advanced");

	%this.addPref("Victory Method","Lives","%mini.lives","int 0 99",0,0,1,-1,"","%mini.updateLives(%1,%2);");
	%this.addPref("Victory Method","Points","%mini.points","int 0 2000",0,0,1,-1,"","%mini.updatePoints(%1,%2);");
	%this.addPref("Victory Method","Time","%mini.time","int 0 999999",0,0,1,-1,"","%mini.updateTime(%1,%2);");

	%this.addPref("Teams","Friendly Fire","%mini.Teams.friendlyFire","bool",0,0,1,-1);
	%this.addPref("Teams","Lock Teams","%mini.Teams.lock","bool",0,0,1,-1);
	%this.addPref("Teams","Auto Sort","%mini.Teams.autoSort","bool",1,0,1,-1);
	%this.addPref("Teams","Balance Teams","%mini.Teams.balanceTeams","bool",1,0,1,-1);
	%this.addPref("Teams","Shuffle Teams","%mini.Teams.shuffleTeams","bool",0,0,1,-1);
	%this.addPref("Teams","Rounds Between Shuffle","%mini.Teams.roundsBetweenShuffles","int 1 999",1,0,1,-1);
	%this.addPref("Teams","Ally Same Colors","%mini.Teams.allySameColors","bool",0,0,1,-1);
	%this.addPref("Teams","Punish Friendly Fire","%mini.Teams.punishFF","bool",1,0,1,3,"Advanced");
	%this.addPref("Teams","Balance New Teams","%mini.Teams.balanceOnNew","bool",1,0,1,3);

	%this.addPref("Capture Points","Tick Time","Slayer_CPTriggerData.tickPeriodMS","int 20 500",150,0,1,-1,"Advanced");
	%this.addPref("Capture Points","Use Transitional Colors","%mini.CPTransitionColors","bool",1,0,1,-1,"Advanced");

	%this.addPref("Teams","Max Team Events","$Slayer::Server::Preload::Teams::maxEvents","int 0 64",6,0,0,0,"Advanced","",1);

	%this.addPref("Chat","Allow Dead Talking","%mini.allowDeadTalk","bool",1,0,1,-1,"Advanced");
	%this.addPref("Chat","Enable Team Chat","%mini.Teams.enableTeamChat","bool",1,0,1,3,"Advanced");
	%this.addPref("Chat","Team Display Mode","%mini.chat_teamDisplayMode","list" TAB "0 Disabled" TAB "1 Color Tag" TAB "2 Color Name" TAB "3 Add Name to Tag",2,0,1,-1,"Advanced");
	%this.addPref("Chat","Death Message Mode","%mini.deathMsgMode","list" TAB "0 Do Not Display" TAB "1 Colored Names" TAB "2 Non-Colored Names",1,0,0,-1,"Advanced");

	//these need to be the last minigame prefs for various reasons
	%this.addPref("Minigame","Gamemode","%mini.mode","string 100","Slyr",1,1,-1,"","%mini.updateGamemode(%1,%2);");
	%this.addPref("Minigame","Default Minigame","%mini.isDefaultMinigame","bool",0,0,1,2,"","%mini.updateDefaultMinigame(%1);");

	%this.addPref("Server","Announcements","Slayer.announcements","string 500","",0,0,-1,"Advanced");


	//LOAD ANY SAVED NON-MINIGAME PREFS
	if(isFile($Slayer::Server::ConfigDir @ "/config_last.cs"))
		exec($Slayer::Server::ConfigDir @ "/config_last.cs");
	%this.setNonMinigamePrefs = 1;

	//LOAD EXISTING PRELOAD CONFIG
	if(isFile($Slayer::Server::ConfigDir @ "/config_preload.cs"))
		exec($Slayer::Server::ConfigDir @ "/config_preload.cs");
}

function Slayer_PrefHandlerSO::sendPrefs(%this,%client,%mini)
{
	if(!isObject(%mini) && %mini != -1)
		%mini = getMinigameFromObject(%client);
	if(isObject(%mini) && !isSlayerMinigame(%mini))
		return;

	Slayer_Support::Debug(2,"Sending Preferences",%client.getSimpleName());

	//START THE PREF TRANSFER
	commandToClient(%client,'Slayer_getPrefs_Start',%this.getCount());

	for(%i=0; %i < %this.getCount(); %i++)
	{
		%p = %this.getObject(%i);

		%val = %this.getPref(%p.category,%p.title,%mini);
		if(isObject(%mini))
			%canEdit = %mini.canEdit(%client,%p.editRights);
		else
		{
			if(%p.editRights <= 2)
				%canEdit = (%p.editRights <= %client.getAdminLvl());
			else
				%canEdit = 1;
		}

		commandToClient(%client,'Slayer_getPrefs_Tick',%p.category,%p.title,%p.type,%p.objectClassName,%p.defaultValue,%val,%canEdit,%p.list);

		Slayer_Support::Debug(2,"Sending pref",%p.category TAB %p.title TAB %p.type TAB %p.defaultValue TAB %val TAB %p.editRights TAB %p.list);
	}

	//END THE PREF TRANSFER
	commandToClient(%client,'Slayer_getPrefs_End',%this.getCount());
}

// +---------------+
// | Slayer_PrefSO |
// +---------------+
function Slayer_PrefSO::setValue(%this,%value)
{
	
}

function Slayer_PrefSO::getValue(%this)
{
	
}

// +------------+
// | serverCmds |
// +------------+
function serverCmdSlayer_getPrefs_Start(%client,%reset,%count,%notify)
{
	%mini = %client.editingMinigame;
	if(!isObject(%mini))
		%mini = getMinigameFromObject(%client);

	if(isSlayerMinigame(%mini) && !%mini.canEdit(%client))
	{
		return;
	}
	else if(!isObject(%mini)) //minigame creation
	{
		if(Slayer.Minigames.canCreate(%client))
		{
			%mini = Slayer.Minigames.addMinigame(%client);
			if(!isObject(%mini))
				return;
			%client.editingMinigame = %mini;
		}
		else
		{
			return;
		}
	}

	%mini.requiresReset = %reset;
	%mini.notifyOnChange = %notify;

	if(%count > 0)
	{
		%message = '\c3%1 \c5updated the \c3%2 \c5minigame.';
		%mini.messageAll('',%message,%client.getPlayerName(),%mini.title);
	}
}

function serverCmdSlayer_getPrefs_Tick(%client,%category,%title,%value)
{
	%mini = %client.editingMinigame;
	if(!isObject(%mini))
		%mini = getMinigameFromObject(%client);

	if(!isSlayerMinigame(%mini))
		return;

	%p = Slayer.Prefs.getPrefSO(%category,%title);

	//make sure that nobody can change things without permission
	if(!%mini.canEdit(%client,%p.editRights))
		return;

	Slayer_Support::Debug(2,"Preference Recieved",%category TAB %title TAB %value);

	//idiot-proofing
	%type = %p.type;
	switch$(getWord(%type,0))
	{
		case string:
			%value = getSubStr(%value,0,getWord(%type,1));

		case int:
			if(!Slayer_Support::isNumber(%value))
				return;
			%value = Slayer_Support::StripTrailingZeros(%value);
			%value = Slayer_Support::mRestrict(%value,getWord(%type,1),getWord(%type,2));

		case slide:
			if(!Slayer_Support::isNumber(%value))
				return;
			%value = Slayer_Support::StripTrailingZeros(%value);
			%value = Slayer_Support::mRestrict(%value,getWord(%type,1),getWord(%type,2));
	}

	if(%mini.getPref(%category,%title) $= %value)
		return;

	//tell players that the pref was updated
	if(%p.notify && %mini.notifyOnChange)
	{
		switch$(getWord(%type,0))
		{
			case bool:
				if(%value)
					%val = "True";
				else
					%val = "False";

			case list:
				for(%i=0; %i < getFieldCount(%type); %i++)
				{
					%f = getField(%type,%i);
					if(firstWord(%f) $= %value)
					{
						%val = restWords(%f);
						break;
					}
				}

			default:
				%val = %value;
		}

		%message = '\c3 + \c5[\c3%1\c5|\c3%2\c5] is now \c3%3';
		%mini.messageAll('',%message,%category,%title,%val);
	}

	//does the minigame need to be reset once all prefs are loaded?
	if(%p.requiresReset)
		%mini.requiresReset = 1;

	%mini.setPref(%category,%title,%value);
}

function serverCmdSlayer_getPrefs_End(%client)
{
	%mini = %client.editingMinigame;
	if(!isObject(%mini))
		%mini = getMinigameFromObject(%client);

	if(!isSlayerMinigame(%mini))
		return;

	if(!%mini.canEdit(%client))
		return;

	//new teams
	if(%mini.notifyOnChange && %mini.notifyNewTeam > 0)
	{
		%newTeams = (%mini.notifyNewTeam == 1 ? "team" : "teams");
		%mini.messageAll('',"\c3 + \c5Added\c3" SPC %mini.notifyNewTeam SPC "\c5new" SPC %newTeams @ ".");
		%mini.messageAll('',"\c3 + + \c5Type \c3/listTeams \c5to view a list of teams and \c3/joinTeam [Team Name] \c5to join a team.");
		if(%mini.Teams.balanceOnNew)
		{
			%mini.messageAll('',"\c3 + + \c5Teams have been \c3balanced\c5.");
		}
	}

	//check if the minigame should be reset
	if(%mini.requiresReset)
		%mini.Reset(%client);

	%mini.requiresReset = 0;
	%mini.notifyNewTeam = 0;
	%mini.notifyOnChange = 0;

	//update the Join Minigame menu
	%mini.broadcastMinigame();

	%client.editingMinigame = "";
}

function serverCmdSlayer_saveConfig(%client,%fileName)
{
	if(%client.isSpamming())
		return;

	%fileName = strReplace(%fileName," ","");
	if(%fileName $= "")
		return;

	%mini = getMinigameFromObject(%client);
	if(!isSlayerMinigame(%mini))
		return;
	if(!%mini.canEdit(%client))
		return;

	%path = $Slayer::Server::ConfigDir @ "/config_saved/config_" @ %fileName @ ".cs";
	Slayer.Prefs.exportPrefs(%path,%mini);

	messageClient(%client,'',"Config saved as \"" @ %fileName @ "\"");
}

function serverCmdSlayer_loadConfig(%client,%filename)
{
	if(%client.isSpamming())
		return;

	%mini = getMinigameFromObject(%client);
	if(!isSlayerMinigame(%mini))
		return;
	if(!%mini.canEdit(%client))
		return;

	%path = $Slayer::Server::ConfigDir @ "/config_saved/config_" @ %fileName @ ".cs";
	if(!isFile(%path))
		return;

	exec(%path);

	//hide the GUI
	commandToClient(%client,'Slayer_forceGUI',"ALL",0);

	%mini.reset(%client);
	%mini.messageAll('',%client.getPlayerName() SPC "loaded a minigame config file.");
}

// +----------------------+
// | Initialize Component |
// +----------------------+
if(!isObject(Slayer.Prefs))
{
	if(!isObject(Slayer))
		exec("Add-ons/Gamemode_Slayer/Main.cs");

	Slayer.Prefs = new scriptGroup(Slayer_PrefHandlerSO);
	Slayer.add(Slayer.Prefs);
}

Slayer_Support::Debug(2,"Dependency Loaded","Preferences");